import { DataSignal } from "./S.js";
import type { NameSpace } from "./env.js";
export { AttrsItem, ElementAttrs, parseAndSetAttrs, setAttrs };
interface Event {
    [x: string]: EventListenerOrEventListenerObject | [EventListenerOrEventListenerObject] | [EventListenerOrEventListenerObject, AddEventListenerOptions | boolean];
}
declare type EventOrStreamThereof = Event | (() => Event) | DataSignal<Event>;
declare type AttrsItem = {
    on?: EventOrStreamThereof;
    $attrs?: {
        [x: string]: any;
    };
    $props?: {
        [x: string]: any;
    };
    [x: string]: any;
};
declare type ElementAttrs = AttrsItem | AttrsItem[];
declare function setAttrs(el: HTMLElement | SVGElement, attrs: ElementAttrs, ns: NameSpace, tagName: string): void;
declare function parseAndSetAttrs(element: HTMLElement | SVGElement, s: string, ns: NameSpace): void;
