import { Emitable, NonNullNodeRange } from "./render.js";
import { Nullish } from "./types.js";
export { FragmentIndex, RemoveHooks, ref, postpone, setRemoveManager, processHookQueue };
interface FragmentIndex {
    fragmentIndex: number;
    lastFragmentIndex: number;
}
declare type Effector<T> = (() => T) | ((node: Node) => T) | ((node: Node, fi: FragmentIndex) => T);
declare const removeHooks: () => ({
    manager: typeof Promise.all | Nullish;
    hooks: ((x: Array<Promise<unknown> | Nullish>) => void)[];
});
declare type RemoveHooks = ReturnType<typeof removeHooks>;
declare function setRemoveManager(cb: typeof Promise.all): void;
declare type Life = (life: {
    asap: (cb: Effector<void>) => void;
    rendered: (cb: Effector<void>) => void;
    reflowed: (cb: Effector<void>) => void;
    removing: (cb: Effector<Nullish | Promise<unknown>>) => void;
}) => Emitable;
declare function ref(cb: Life): import("./render.js").ComponentResult;
declare function postpone(what: "rendered" | "reflowed", fn: Effector<void>, nr: NonNullNodeRange): void;
declare function postpone(what: "removing", fn: Effector<Promise<unknown> | Nullish>, nr: NonNullNodeRange): void;
declare function processHookQueue(queue: (Effector<void> | NonNullNodeRange)[]): void;
